=== debian/changelog ===
mfem (4.8+ds-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.2.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Tue, 28 Oct 2025 13:16:14 +0100
