=== debian/tests/control ===
Tests: cmake
Depends: gcc, build-essential, cmake, @
